Index: branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 8487)
+++ branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 8490)
@@ -137,4 +137,101 @@
       <DependentUpon>ClassificationEnsembleSolutionModelView.cs</DependentUpon>
     </Compile>
+    <Compile Include="DataAnalysisSolutionEvaluationView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="DataAnalysisSolutionEvaluationView.Designer.cs">
+      <DependentUpon>DataAnalysisSolutionEvaluationView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Regression\RegressionEnsembleSolutionModelView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Regression\RegressionEnsembleSolutionModelView.Designer.cs">
+      <DependentUpon>RegressionEnsembleSolutionModelView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionErrorCharacteristicsCurveView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionErrorCharacteristicsCurveView.Designer.cs">
+      <DependentUpon>RegressionSolutionErrorCharacteristicsCurveView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionEstimatedValuesView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionEstimatedValuesView.Designer.cs">
+      <DependentUpon>RegressionSolutionEstimatedValuesView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionLineChartView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionLineChartView.Designer.cs">
+      <DependentUpon>RegressionSolutionLineChartView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionResidualHistogram.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionResidualHistogram.Designer.cs">
+      <DependentUpon>RegressionSolutionResidualHistogram.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionScatterPlotView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Regression\RegressionSolutionScatterPlotView.Designer.cs">
+      <DependentUpon>RegressionSolutionScatterPlotView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Solution Views\ClassificationSolutionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Solution Views\ClassificationSolutionView.Designer.cs">
+      <DependentUpon>ClassificationSolutionView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Classification\ClassificationSolutionConfusionMatrixView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Classification\ClassificationSolutionConfusionMatrixView.Designer.cs">
+      <DependentUpon>ClassificationSolutionConfusionMatrixView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Classification\ClassificationSolutionEstimatedClassValuesView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Classification\ClassificationSolutionEstimatedClassValuesView.Designer.cs">
+      <DependentUpon>ClassificationSolutionEstimatedClassValuesView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Classification\DiscriminantFunctionClassificationSolutionEstimatedClassValuesView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Classification\DiscriminantFunctionClassificationSolutionEstimatedClassValuesView.Designer.cs">
+      <DependentUpon>DiscriminantFunctionClassificationSolutionEstimatedClassValuesView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Classification\DiscriminantFunctionClassificationRocCurvesView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Classification\DiscriminantFunctionClassificationRocCurvesView.Designer.cs">
+      <DependentUpon>DiscriminantFunctionClassificationRocCurvesView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Classification\DiscriminantFunctionClassificationSolutionThresholdView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Classification\DiscriminantFunctionClassificationSolutionThresholdView.Designer.cs">
+      <DependentUpon>DiscriminantFunctionClassificationSolutionThresholdView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Clustering\ClusteringSolutionEstimatedClusterView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Clustering\ClusteringSolutionEstimatedClusterView.Designer.cs">
+      <DependentUpon>ClusteringSolutionEstimatedClusterView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Solution Views\ClusteringSolutionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Solution Views\ClusteringSolutionView.Designer.cs">
+      <DependentUpon>ClusteringSolutionView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Solution Views\ClassificationEnsembleSolutionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Solution Views\ClassificationEnsembleSolutionView.Designer.cs">
+      <DependentUpon>ClassificationEnsembleSolutionView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Solution Views\TimeSeriesPrognosisSolutionView.cs">
       <SubType>UserControl</SubType>
@@ -142,101 +239,4 @@
     <Compile Include="Solution Views\TimeSeriesPrognosisSolutionView.Designer.cs">
       <DependentUpon>TimeSeriesPrognosisSolutionView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="DataAnalysisSolutionEvaluationView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="DataAnalysisSolutionEvaluationView.Designer.cs">
-      <DependentUpon>DataAnalysisSolutionEvaluationView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Plugin.cs" />
-    <Compile Include="Regression\RegressionEnsembleSolutionModelView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Regression\RegressionEnsembleSolutionModelView.Designer.cs">
-      <DependentUpon>RegressionEnsembleSolutionModelView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionErrorCharacteristicsCurveView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionErrorCharacteristicsCurveView.Designer.cs">
-      <DependentUpon>RegressionSolutionErrorCharacteristicsCurveView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionEstimatedValuesView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionEstimatedValuesView.Designer.cs">
-      <DependentUpon>RegressionSolutionEstimatedValuesView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionLineChartView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionLineChartView.Designer.cs">
-      <DependentUpon>RegressionSolutionLineChartView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionResidualHistogram.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionResidualHistogram.Designer.cs">
-      <DependentUpon>RegressionSolutionResidualHistogram.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionScatterPlotView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Regression\RegressionSolutionScatterPlotView.Designer.cs">
-      <DependentUpon>RegressionSolutionScatterPlotView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Solution Views\ClassificationSolutionView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Solution Views\ClassificationSolutionView.Designer.cs">
-      <DependentUpon>ClassificationSolutionView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Classification\ClassificationSolutionConfusionMatrixView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Classification\ClassificationSolutionConfusionMatrixView.Designer.cs">
-      <DependentUpon>ClassificationSolutionConfusionMatrixView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Classification\ClassificationSolutionEstimatedClassValuesView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Classification\ClassificationSolutionEstimatedClassValuesView.Designer.cs">
-      <DependentUpon>ClassificationSolutionEstimatedClassValuesView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Classification\DiscriminantFunctionClassificationSolutionEstimatedClassValuesView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Classification\DiscriminantFunctionClassificationSolutionEstimatedClassValuesView.Designer.cs">
-      <DependentUpon>DiscriminantFunctionClassificationSolutionEstimatedClassValuesView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Classification\DiscriminantFunctionClassificationRocCurvesView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Classification\DiscriminantFunctionClassificationRocCurvesView.Designer.cs">
-      <DependentUpon>DiscriminantFunctionClassificationRocCurvesView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Classification\DiscriminantFunctionClassificationSolutionThresholdView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Classification\DiscriminantFunctionClassificationSolutionThresholdView.Designer.cs">
-      <DependentUpon>DiscriminantFunctionClassificationSolutionThresholdView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Clustering\ClusteringSolutionEstimatedClusterView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Clustering\ClusteringSolutionEstimatedClusterView.Designer.cs">
-      <DependentUpon>ClusteringSolutionEstimatedClusterView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Solution Views\ClusteringSolutionView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Solution Views\ClusteringSolutionView.Designer.cs">
-      <DependentUpon>ClusteringSolutionView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Solution Views\ClassificationEnsembleSolutionView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Solution Views\ClassificationEnsembleSolutionView.Designer.cs">
-      <DependentUpon>ClassificationEnsembleSolutionView.cs</DependentUpon>
     </Compile>
     <Compile Include="Solution Views\DiscriminantFunctionClassificationSolutionView.cs">
Index: branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TimeSeriesPrognosisSolutionView.Designer.cs
===================================================================
--- branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TimeSeriesPrognosisSolutionView.Designer.cs	(revision 8487)
+++ branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TimeSeriesPrognosisSolutionView.Designer.cs	(revision 8490)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -45,6 +45,4 @@
     /// </summary>
     private void InitializeComponent() {
-      this.horizonTextBox = new System.Windows.Forms.TextBox();
-      this.label1 = new System.Windows.Forms.Label();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -57,27 +55,8 @@
       // splitContainer
       // 
-      this.splitContainer.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.splitContainer.Dock = System.Windows.Forms.DockStyle.None;
-      this.splitContainer.Location = new System.Drawing.Point(3, 45);
-      this.splitContainer.Size = new System.Drawing.Size(526, 335);
       // 
       // itemsGroupBox
       // 
-      this.itemsGroupBox.Controls.Add(this.horizonTextBox);
-      this.itemsGroupBox.Controls.Add(this.label1);
-      this.itemsGroupBox.Text = "Time Series Prognosis Solution";
-      this.itemsGroupBox.Controls.SetChildIndex(this.label1, 0);
-      this.itemsGroupBox.Controls.SetChildIndex(this.horizonTextBox, 0);
-      this.itemsGroupBox.Controls.SetChildIndex(this.splitContainer, 0);
-      // 
-      // itemsListView
-      // 
-      this.itemsListView.Size = new System.Drawing.Size(244, 153);
-      // 
-      // detailsGroupBox
-      // 
-      this.detailsGroupBox.Size = new System.Drawing.Size(266, 161);
+      this.itemsGroupBox.Text = "Regression Solution";
       // 
       // addButton
@@ -89,31 +68,9 @@
       this.toolTip.SetToolTip(this.removeButton, "Remove");
       // 
-      // viewHost
-      // 
-      this.viewHost.Size = new System.Drawing.Size(254, 136);
-      // 
-      // horizonTextBox
-      // 
-      this.horizonTextBox.Location = new System.Drawing.Point(66, 19);
-      this.horizonTextBox.Name = "horizonTextBox";
-      this.horizonTextBox.Size = new System.Drawing.Size(100, 20);
-      this.horizonTextBox.TabIndex = 1;
-      this.horizonTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.horizonTextBox_Validating);
-      this.horizonTextBox.Validated += new System.EventHandler(this.horizonTextBox_Validated);
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(6, 22);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(46, 13);
-      this.label1.TabIndex = 2;
-      this.label1.Text = "Horizon:";
-      // 
-      // TimeSeriesPrognosisSolutionView
+      // RegressionSolutionView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Name = "TimeSeriesPrognosisSolutionView";
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Name = "RegressionSolutionView";
       this.splitContainer.Panel1.ResumeLayout(false);
       this.splitContainer.Panel2.ResumeLayout(false);
@@ -121,5 +78,4 @@
       this.splitContainer.ResumeLayout(false);
       this.itemsGroupBox.ResumeLayout(false);
-      this.itemsGroupBox.PerformLayout();
       this.detailsGroupBox.ResumeLayout(false);
       this.ResumeLayout(false);
@@ -128,8 +84,4 @@
 
     #endregion
-
-    private System.Windows.Forms.TextBox horizonTextBox;
-    private System.Windows.Forms.Label label1;
-
   }
 }
Index: branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TimeSeriesPrognosisSolutionView.cs
===================================================================
--- branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TimeSeriesPrognosisSolutionView.cs	(revision 8487)
+++ branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TimeSeriesPrognosisSolutionView.cs	(revision 8490)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -25,7 +25,7 @@
 
 namespace HeuristicLab.Problems.DataAnalysis.Views {
-  [View("TimeSeriesPrognosisnSolution View")]
+  [View("TimeSeriesPrognosisSolution View")]
   [Content(typeof(TimeSeriesPrognosisSolution), false)]
-  public partial class TimeSeriesPrognosisSolutionView : DataAnalysisSolutionView {
+  public partial class TimeSeriesPrognosisSolutionView : RegressionSolutionView {
     public TimeSeriesPrognosisSolutionView() {
       InitializeComponent();
@@ -37,11 +37,4 @@
     }
 
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content != null) {
-        //horizonTextBox.Text = Content.Horizon.ToString();
-      }
-    }
-
     #region drag and drop
     protected override void itemsListView_DragEnter(object sender, DragEventArgs e) {
@@ -50,26 +43,11 @@
 
       var dropData = e.Data.GetData(HeuristicLab.Common.Constants.DragDropDataFormat);
-      if (dropData is TimeSeriesPrognosisProblemData) validDragOperation = true;
+      if (dropData is ITimeSeriesPrognosisProblemData) validDragOperation = true;
       else if (dropData is IValueParameter) {
         var param = (IValueParameter)dropData;
-        if (param.Value is TimeSeriesPrognosisProblemData) validDragOperation = true;
+        if (param.Value is ITimeSeriesPrognosisProblemData) validDragOperation = true;
       }
     }
     #endregion
-
-    private void horizonTextBox_Validating(object sender, System.ComponentModel.CancelEventArgs e) {
-      int val;
-      if (int.TryParse(horizonTextBox.Text, out val)) {
-        //e.Cancel = val <= 0 || val >= Content.ProblemData.TrainingPartition.End - Content.ProblemData.TrainingPartition.Start;
-      } else {
-        e.Cancel = true;
-      }
-    }
-
-    private void horizonTextBox_Validated(object sender, System.EventArgs e) {
-      int val;
-      int.TryParse(horizonTextBox.Text, out val);
-      //Content.Horizon = val;
-    }
   }
 }