Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CrossoverPerformanceAnalyzer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CrossoverPerformanceAnalyzer.cs	(revision 8503)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CrossoverPerformanceAnalyzer.cs	(revision 8505)
@@ -77,10 +77,17 @@
     #endregion
 
+    [Storable]
     private ScatterPlotHelper plotHelper, childDiversityHelper, parentDiversityHelper;
+    [Storable]
     private DataTableHelper performanceHelper, successHelper, equalParentsHelper;
+    [Storable]
     private int cnt = 0;
+    [Storable]
     private int success = 0;
+    [Storable]
     private int lastGeneration = 0;
+    [Storable]
     private int equalParents = 0;
+    [Storable]
     private List<double> qualityPoints = new List<double>();
 
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/DataTableHelper.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/DataTableHelper.cs	(revision 8503)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/DataTableHelper.cs	(revision 8505)
@@ -30,7 +30,11 @@
   public class DataTableHelper : Item {
 
+    [Storable]
     private ResultCollection resultsCol;
+    [Storable]
     private string chartName;
+    [Storable]
     private string dataRowName;
+    [Storable]
     private DataRow dtRow;
 
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/DuplicateSolutionsAnalyzer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/DuplicateSolutionsAnalyzer.cs	(revision 8503)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/DuplicateSolutionsAnalyzer.cs	(revision 8505)
@@ -56,4 +56,5 @@
     }
 
+    [Storable]
     private DataTableHelper chartingHelper;
     #endregion
@@ -61,5 +62,9 @@
     [StorableConstructor]
     private DuplicateSolutionsAnalyzer(bool deserializing) : base(deserializing) { }
-    private DuplicateSolutionsAnalyzer(DuplicateSolutionsAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    
+    private DuplicateSolutionsAnalyzer(DuplicateSolutionsAnalyzer original, Cloner cloner) : base(original, cloner) {
+      chartingHelper = (DataTableHelper)original.chartingHelper.Clone(cloner);
+    }
+    
     public DuplicateSolutionsAnalyzer()
       : base() {
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/MutationPerformanceAnalyzer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/MutationPerformanceAnalyzer.cs	(revision 8503)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/MutationPerformanceAnalyzer.cs	(revision 8505)
@@ -74,7 +74,11 @@
     #endregion
 
+    [Storable]
     private ScatterPlotHelper diversityPlotHelper, qualityPlotHelper;
+    [Storable]
     private DataTableHelper avgDataTableHelper;
+    [Storable]
     private int cnt = 0, lastGeneration = 0;
+    [Storable]
     private List<double> qualityPoints = new List<double>();
 
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/ScatterPlotHelper.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/ScatterPlotHelper.cs	(revision 8503)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/ScatterPlotHelper.cs	(revision 8505)
@@ -31,9 +31,14 @@
   public class ScatterPlotHelper : Item {
 
+    [Storable]
     private ResultCollection resultsCol;
+    [Storable]
     private string chartName;
+    [Storable]
     private string xAxisTitle;
+    [Storable]
     private string yAxisTitle;
 
+    [Storable]
     private ScatterPlot plot;
     public ScatterPlot Plot {